Skip to content

Since sing-box 1.12.0

# Hosts

### Structure

    {
      "dns": {
        "servers": [
          {
            "type": "hosts",
            "tag": "",

            "path": [],
            "predefined": {}
          }
        ]
      }
    }

You can ignore the JSON Array [] tag when the content is only one item

### Fields

#### path

List of paths to hosts files.

`/etc/hosts` is used by default.

`C:\Windows\System32\Drivers\etc\hosts` is used by default on Windows.

Example:

    {
      // "path": "/etc/hosts"

      "path": [
        "/etc/hosts",
        "$HOME/.hosts"
      ]
    }

#### predefined

Predefined hosts.

Example:

    {
      "predefined": {
        "www.google.com": "127.0.0.1",
        "localhost": [
          "127.0.0.1",
          "::1"
        ]
      }
    }

### Examples

Use hosts if available

    {
      "dns": {
        "servers": [
          {
            ...
          },
          {
            "type": "hosts",
            "tag": "hosts"
          }
        ],
        "rules": [
          {
            "ip_accept_any": true,
            "server": "hosts"
          }
        ]
      }
    }